Attribute VB_Name = "DNATokenizing"
Option Explicit

'''''''''''''''''''''''''''''''''''''''''''''''
'All the routines that tokenize and detokenize
'DNA go in here
'''''''''''''''''''''''''''''''''''''''''''''''

' loads the dna and parses it
Public Function LoadDNA(path As String, n As Integer) As Boolean
  On Error GoTo fine:
  Dim A As String
  Dim b As String
  Dim pos As Long
  Dim DNApos As Long
  Dim hold As String
inizio:

  A = ""
  b = ""
  pos = 0
  DNApos = 0
  hold = ""
  
  ReDim rob(n).DNA(0)
  DNApos = 0
  Open path For Input As #1
  While Not EOF(1)
    Line Input #1, A
    
    ' eliminate comments at the end of a line
    ' but preserves comments-only lines
    pos = InStr(A, "'")
    If pos > 1 Then A = Left(A, pos - 1)
    If Right(A, 2) = vbCrLf Then A = Left(A, Len(A) - 2)
    
    hold = hold + A
    A = Trim(A)
       
    If (Left(A, 1) <> "'" And Left(A, 1) <> "/") And A <> "" Then
        If Left(A, 3) = "shp" Or Left(A, 3) = "def" Then
          If Left(A, 3) = "shp" Then  'inserts robot shape
            rob(n).Shape = val(Right(A, 1))
          End If
          If Left(A, 3) = "def" Then  'inserts user defined labels as sysvars
            insertvar n, A
          End If
        Else
          pos = InStr(A, " ")
          While pos <> 0
            b = Left(A, pos - 1)
            A = Right(A, Len(A) - pos)
            
            While Left(A, 0) = " "
              A = Right(A, Len(A) - 1)
            Wend
            pos = InStr(A, " ")
            
            If b <> "" Then
              DNApos = DNApos + 1
              If DNApos > UBound(rob(n).DNA()) Then
                ReDim Preserve rob(n).DNA(DNApos + 5)
              End If
              Parse b, rob(n).DNA(DNApos), n
            End If
          Wend
          If A <> "" Then
            DNApos = DNApos + 1
            If DNApos > UBound(rob(n).DNA()) Then
              ReDim Preserve rob(n).DNA(DNApos + 5)
            End If
            Parse A, rob(n).DNA(DNApos), n
          End If
        End If
    Else
      If Left(A, 2) = "'#" Or Left(A, 2) = "/#" Then
        ' embryo of a new feature, should allow recording
        ' in dna files info such robot colour, generation,
        ' mutations etc
        getvals n, A, hold
      End If
    End If
here:
  Wend
  Close 1
  LoadDNA = True
  DNApos = DNApos + 1
  If DNApos > UBound(rob(n).DNA()) Then
    ReDim Preserve rob(n).DNA(DNApos + 1)
  End If
  rob(n).DNA(DNApos).tipo = 10
  rob(n).DNA(DNApos).value = 1
  ReDim Preserve rob(n).DNA(DnaLen(rob(n).DNA()))
  Exit Function
  
fine:
  pos = Err.Number
  If Err.Number = 53 Then
    Form1.CommonDialog1.DialogTitle = WScannotfind + path
    Form1.CommonDialog1.ShowOpen
    path = Form1.CommonDialog1.filename
    GoTo inizio
  Else
    Close 1
    MsgBox Err.Description + ".  Path: " + path + MBnovalidrob
    LoadDNA = False
  End If
End Function

' parses dna code, tokenizing or detokenizing instructions in the block
' structure
' types:
' 0 = number
' 1 = *number
' 2 = basic command
' 3 = advanced command
' 4 = bitwise command
' 5 = conditions
' 6 = logic
' 7 = stores
' 8 = Empty
' 9 = flow
' 10= Master flow
'
' if the string it's passed is "", then it will
' detokenize the command sent to it via bp and store in into command
'
' if the string it's passed isn't empty, then it will
' tokenize the string into the bp block.  If the command isn't
' recognized then it inserts 0.0 (that is, the number 0)
'
' this is all done byref, so be sure to understand that your variables
' WILL change after going through this subfunction.  Be sure to save any
' data you don't want modified elsewhere
Public Sub Parse(ByRef Command As String, ByRef bp As block, Optional n As Integer = 0, Optional converttosysvar As Boolean = True)
  Dim detok As Boolean
  detok = IIf(Command = "", True, False)
  
  If detok Then
    Select Case bp.tipo
      Case 0 'number
        If converttosysvar = True Then
          Command = SysvarDetok(bp.value, n)
        Else
          Command = bp.value
        End If
      Case 1 '*.number
        Command = "*" + SysvarDetok(bp.value, n)
      Case 2 'basic commands
        Command = BasicCommandDetok(bp.value)
      Case 3 'advanced commands
        Command = AdvancedCommandDetok(bp.value)
      Case 4 'bit commands
        'command =
      Case 5 'conditions
        Command = ConditionsDetok(bp.value)
      Case 6 'logic
        Command = LogicDetok(bp.value)
      Case 7 'stores
        Command = StoresDetok(bp.value)
      Case 8
        'nothing
      Case 9
        Command = FlowDetok(bp.value)
      Case 10
        Command = MasterFlowDetok(bp.value)
    End Select
  Else
    bp.value = 0
    
    'if command = "end" then
    
    If bp.value = 0 Then bp = BasicCommandTok(Command)
    If bp.value = 0 Then bp = AdvancedCommandTok(Command)
    If bp.value = 0 Then bp = ConditionsTok(Command)
    If bp.value = 0 Then bp = LogicTok(Command)
    If bp.value = 0 Then bp = StoresTok(Command)
    If bp.value = 0 Then bp = FlowTok(Command)
    If bp.value = 0 Then bp = MasterFlowTok(Command)
    If bp.value = 0 And Left(Command, 1) = "*" Then
      bp.tipo = 1
      bp.value = SysvarTok(Right(Command, Len(Command) - 1), n)
    ElseIf bp.value = 0 Then
      bp.tipo = 0
      bp.value = SysvarTok(Command, n)
    End If
  End If
End Sub

Public Function SysvarDetok(n As Integer, Optional robn As Integer = 0) As String
  Dim t As Integer
  
  SysvarDetok = n
  
  While sysvar(t + 1).value <> 0
    If sysvar(t + 1).value = n Then SysvarDetok = "." + sysvar(t + 1).Name
    t = t + 1
  Wend
  
  If robn > 0 Then
    For t = 1 To UBound(rob(robn).vars)
      If rob(robn).vars(t).value = n Then SysvarDetok = "." + rob(robn).vars(t).Name
    Next t
  End If
  
End Function

Public Function SysvarTok(A As String, Optional n As Integer = 0) As Integer
  Dim t As Integer
  
  If Left(A, 1) = "." Then
    A = Right(A, Len(A) - 1)
        
    For t = 1 To UBound(sysvar)
      If sysvar(t).Name = A Then SysvarTok = sysvar(t).value
    Next t
    
    If n > 0 Then
      For t = 1 To UBound(rob(n).vars)
        If rob(n).vars(t).Name = A Then SysvarTok = rob(n).vars(t).value
      Next t
    End If
  Else
    SysvarTok = val(A)
  End If
End Function

Private Function BasicCommandDetok(n As Integer) As String
  BasicCommandDetok = ""
  Select Case n
    Case 1
      BasicCommandDetok = "add"
    Case 2
      BasicCommandDetok = "sub"
    Case 3
      BasicCommandDetok = "mult"
    Case 4
      BasicCommandDetok = "div"
    Case 5
      BasicCommandDetok = "rnd"
    Case 6
      BasicCommandDetok = "valinc"
    Case 7
      BasicCommandDetok = "valdec"
    Case 8
      BasicCommandDetok = "-"
    Case 9
      BasicCommandDetok = "*"
    Case 10
      BasicCommandDetok = "mod"
    Case 11
      BasicCommandDetok = "sgn"
    Case 12
      BasicCommandDetok = "abs"
    Case 13
      BasicCommandDetok = "dup"
  End Select
End Function

Private Function BasicCommandTok(s As String) As block
  BasicCommandTok.value = 0
  BasicCommandTok.tipo = 2
  Select Case s
    Case "add"
      BasicCommandTok.value = 1
    Case "sub"
      BasicCommandTok.value = 2
    Case "mult"
      BasicCommandTok.value = 3
    Case "div"
      BasicCommandTok.value = 4
    Case "rnd"
      BasicCommandTok.value = 5
    Case "valinc"
      BasicCommandTok.value = 6
    Case "valdec"
      BasicCommandTok.value = 7
    Case "-"
      BasicCommandTok.value = 8
    Case "*"
      BasicCommandTok.value = 9
    Case "mod"
      BasicCommandTok.value = 10
    Case "sgn"
      BasicCommandTok.value = 11
    Case "abs"
      BasicCommandTok.value = 12
    Case "dup"
      BasicCommandTok.value = 13
  End Select
End Function

Private Function AdvancedCommandDetok(n As Integer) As String
  AdvancedCommandDetok = ""
  Select Case n
    Case 1
      AdvancedCommandDetok = "findang"
    Case 2
      AdvancedCommandDetok = "finddist"
    Case 3
      AdvancedCommandDetok = "ceil"
    Case 4
      AdvancedCommandDetok = "floor"
    Case 5
      AdvancedCommandDetok = "sqr"
    Case 6
      AdvancedCommandDetok = "pow"
    Case 7
      AdvancedCommandDetok = "pyth"
  End Select
End Function

Private Function AdvancedCommandTok(s As String) As block
  AdvancedCommandTok.value = 0
  AdvancedCommandTok.tipo = 3
  Select Case s
    Case "finang"
      AdvancedCommandTok.value = 1
    Case "finddist"
      AdvancedCommandTok.value = 2
    Case "ceil"
      AdvancedCommandTok.value = 3
    Case "floor"
      AdvancedCommandTok.value = 4
    Case "sqr"
      AdvancedCommandTok.value = 5
    Case "power"
      AdvancedCommandTok.value = 6
    Case "pyth"
      AdvancedCommandTok.value = 7
  End Select
End Function

Private Function ConditionsDetok(n As Integer) As String
  ConditionsDetok = ""
  Select Case n
    Case 1
      ConditionsDetok = "<"
    Case 2
      ConditionsDetok = ">"
    Case 3
      ConditionsDetok = "="
    Case 4
      ConditionsDetok = "!="
    Case 5
      ConditionsDetok = "%="
    Case 6
      ConditionsDetok = "!%="
    Case 7
      ConditionsDetok = "~="
    Case 8
      ConditionsDetok = "!~="
    Case 9
      ConditionsDetok = ">="
    Case 10
      ConditionsDetok = "<="
  End Select
End Function

Private Function ConditionsTok(s As String) As block
  ConditionsTok.value = 0
  ConditionsTok.tipo = 5
  Select Case s
    Case "<"
      ConditionsTok.value = 1
    Case ">"
      ConditionsTok.value = 2
    Case "="
      ConditionsTok.value = 3
    Case "!="
      ConditionsTok.value = 4
    Case "%="
      ConditionsTok.value = 5
    Case "!%="
      ConditionsTok.value = 6
    Case "~="
      ConditionsTok.value = 7
    Case "!~="
      ConditionsTok.value = 8
    Case ">="
      ConditionsTok.value = 9
    Case "<="
      ConditionsTok.value = 10
  End Select
End Function

Private Function LogicDetok(n As Integer) As String
  LogicDetok = ""
  Select Case n
    Case 1
      LogicDetok = "and"
    Case 2
      LogicDetok = "or"
    Case 3
      LogicDetok = "xor"
    Case 4
      LogicDetok = "not"
  End Select
End Function

Private Function LogicTok(s As String) As block
  LogicTok.value = 0
  LogicTok.tipo = 6
  Select Case s
    Case "and"
      LogicTok.value = 1
    Case "or"
      LogicTok.value = 2
    Case "xor"
      LogicTok.value = 3
    Case "not"
      LogicTok.value = 4
  End Select
End Function

Private Function StoresDetok(n As Integer) As String
  StoresDetok = ""
  Select Case n
    Case 1
      StoresDetok = "store"
    Case 2
      StoresDetok = "inc"
    Case 3
      StoresDetok = "dec"
  End Select
End Function

Private Function StoresTok(s As String) As block
  StoresTok.value = 0
  StoresTok.tipo = 7
  Select Case s
    Case "store"
      StoresTok.value = 1
    Case "inc"
      StoresTok.value = 2
    Case "dec"
      StoresTok.value = 3
  End Select
End Function

Private Function FlowDetok(n As Integer) As String
  FlowDetok = ""
  Select Case n
    Case 1
      FlowDetok = "cond"
    Case 2
      FlowDetok = "start"
    Case 3
      FlowDetok = "else"
    Case 4
      FlowDetok = "stop"
  End Select
End Function

Private Function FlowTok(s As String) As block
  FlowTok.value = 0
  FlowTok.tipo = 9
  Select Case s
    Case "cond"
      FlowTok.value = 1
    Case "start"
      FlowTok.value = 2
    Case "else"
      FlowTok.value = 3
    Case "stop"
      FlowTok.value = 4
  End Select
End Function

Private Function MasterFlowDetok(n As Integer) As String
  MasterFlowDetok = ""
  Select Case n
    Case 1
      MasterFlowDetok = "end"
  End Select
End Function

Private Function MasterFlowTok(s As String) As block
  MasterFlowTok.tipo = 10
  Select Case s
    Case "end"
      MasterFlowTok.value = 1
  End Select
End Function

' embryo of a new feature, should allow recording
' in dna files info such robot colour, generation, mutations etc
Private Sub getvals(n As Integer, ByVal A As String, hold As String)
 Dim r As Integer
 Dim g As Integer
 Dim b As Integer
 Static fname As String
 Static generation As Long
 Static Mutations As Long
 Dim Name As String
 Dim value As String
 
 ' here we divide the string in its two parts
 ' parameter's name and value, which shall be separated by ':'
 Name = Left$(A, InStr(A, ":") - 1)
 value = Right$(A, Len(A) - InStr(A, ":"))
 Name = Trim(Name)
 Name = Mid$(Name, 3)
 value = Trim(value)
 
 ' here we take the appropriate action
 ' depending on the parameter's name
 ' we record it in the rob structure or, if we want to wait
 ' to check the hash before, in a temporary static variable
 If Name = "name" Then
   fname = value
   rob(n).fname = fname
 End If
 If Name = "generation" Then
   generation = val(value)
 End If
 If Name = "mutations" Then
   Mutations = val(value)
 End If
 
 ' if the current parameter is the hash string, we take its value,
 ' calculate the hash for the dna string from the beginning to
 ' the hash parameter, and compare the two. If they are the same,
 ' we can set the "important" parameters of the robot
 ' (until now they were recorded in static variables)
 If Name = "hash" Then
   hold = Left(hold, InStr(hold, "'#hash:") - 1)
   If Hash(hold, 20) = value Then
     rob(n).fname = fname
     rob(n).generation = generation
     rob(n).Mutations = Mutations
   Else
     MsgBox fname + "'s dna hashing incorrect - ignoring parameters", vbExclamation
   End If
 End If
 
 'If Left$(a, 6) = "color:" Then
 '  'additem function was changed to not apply a random color if a color exists for it already
 '  'bot knows what color it is or wants to be
 '  a = Right$(a, Len(a) - 6)
 '  rob(n).color = Hex(a)
 'End If
End Sub

' calculates the hash function, i.e. simply a string of length f
' which is unlikely to be generated by a different input s
Public Function Hash(s As String, f As Integer) As String

  Dim buf(100) As Long
  Dim k As Integer
  Hash = ""
  For k = 0 To f
    buf(k) = 0
  Next k
  For k = 1 To Len(s)
    buf(k Mod f) = buf(k Mod f) + Asc(Mid(s, k, 1))
    buf(k Mod f) = buf(k Mod f) + buf((k - 1) Mod f)
    buf(k Mod f) = buf(k Mod f) Mod 100
  Next k
  For k = 0 To f - 1
    Hash = Hash + Chr(buf(k) Mod 93 + 33)

  Next k
End Function

' saves a robot's header informations; can be padded with any
' other information, such as color, base energy, etc.
Public Function SaveRobHeader(n As Integer) As String
  SaveRobHeader = "'#name: " + rob(n).fname + vbCrLf + _
    "'#generation: " + CStr(rob(n).generation) + vbCrLf + _
    "'#mutations: " + CStr(rob(n).Mutations) + vbCrLf
End Function

' loads the sysvars.txt file
Public Sub LoadSysVars()
  On Error GoTo aiuto
  Dim A As String
  Dim b As String
  Dim t As Integer
  Dim path As String
  Dim k As Integer
  
  'this just helps numsgil not get a 'where is sysvars2.21' error
  'when running from inside VB
  '(PY, feel free to change this to suite your needs as well
  If Left(MDIForm1.MainDir, 15) = "C:\darwinsource" Then _
    MDIForm1.MainDir = "C:\DarwinbotsII"
  
  path = MDIForm1.MainDir + "\sysvars2.21.txt"
  
carica:
  t = 1
  Open path For Input As #1
  While Not EOF(1)
    Input #1, A
    Input #1, b
    sysvar(t).Name = A
    sysvar(t).value = val(b)
    t = t + 1
  Wend
  Close #1
  Exit Sub
aiuto:
  Close 1
  MsgBox MBcannotfindV, , MBwarning
  Form1.CommonDialog1.DialogTitle = "sysvars2.21.txt"
  Form1.CommonDialog1.ShowOpen
  path = Form1.CommonDialog1.filename
  If path <> "" Then
    k = 1
    While InStr(k, path, "\") > 0
      k = InStr(k, path, "\") + 1
    Wend
    MDIForm1.MainDir = Left(path, k - 2)
    GoTo carica
  End If
End Sub

Public Function DetokenizeDNA(n As Integer) As String
  Dim temp As String, t As Long
  Dim tempint As Integer
  Dim converttosysvar As Boolean
  Dim gene As Long
  
  t = 1
  gene = 0
  While Not (rob(n).DNA(t).tipo = 10 And rob(n).DNA(t).value = 1)
    temp = ""
    converttosysvar = IIf(rob(n).DNA(t + 1).tipo = 7, True, False)
    
    Parse temp, rob(n).DNA(t), n, converttosysvar
    
    tempint = rob(n).DNA(t).tipo
    
    'formatting
    If tempint = 5 Or tempint = 6 Or tempint = 7 Or tempint = 9 Then
      
      If rob(n).DNA(t).tipo = 9 And rob(n).DNA(t).value = 1 Then gene = gene + 1
      
      temp = temp + vbCrLf
      
      If rob(n).DNA(t).tipo = 9 And rob(n).DNA(t).value = 4 And Right(DetokenizeDNA, 2) = vbCrLf Then
        temp = temp + vbCrLf
        temp = temp + "''''''''''''''''''''''''"
        temp = temp + "Gene " + Str(gene)
        temp = temp + ": Last 'stop' at position " + Str(t)
        temp = temp + "''''''''''''''''''''''',"
        temp = temp + vbCrLf + vbCrLf
      End If
    End If
    
    DetokenizeDNA = DetokenizeDNA + " " + temp
    
    t = t + 1
  Wend
  t = 0
End Function

Public Function TipoDetok(ByVal tipo As Long) As String
  Select Case tipo
    Case 0
      TipoDetok = "number"
    Case 1
      TipoDetok = "*number"
    Case 2
      TipoDetok = "basic command"
    Case 3
      TipoDetok = "advanced command"
    Case 4
      TipoDetok = "bit command"
    Case 5
      TipoDetok = "comdition"
    Case 6
      TipoDetok = "logic operator"
    Case 7
      TipoDetok = "store command"
    Case 9
      TipoDetok = "flow command"
  End Select
End Function
