Attribute VB_Name = "Robots"
Option Explicit

'
' robot system locations constants
'
Public Const dirup As Integer = 1
Public Const dirdn As Integer = 2
Public Const dirdx As Integer = 3
Public Const dirsx As Integer = 4
Public Const aimdx As Integer = 5
Public Const aimsx As Integer = 6
Public Const shoot As Integer = 7
Public Const shootval As Integer = 8
Public Const robage As Integer = 9
Public Const masssys As Integer = 10
Public Const maxvelsys As Integer = 11
Public Const AimSys As Integer = 18
Public Const SetAim As Integer = 19
Public Const bodgain As Integer = 194
Public Const bodloss As Integer = 195
Public Const velscalar As Integer = 196
Public Const velsx As Integer = 197
Public Const veldx As Integer = 198
Public Const veldn As Integer = 199
Public Const velup As Integer = 200
Public Const vel As Integer = 200
Public Const hit As Integer = 201
Public Const shflav As Integer = 202
Public Const pain As Integer = 203
Public Const pleas As Integer = 204
Public Const hitup As Integer = 205
Public Const hitdn As Integer = 206
Public Const hitdx As Integer = 207
Public Const hitsx As Integer = 208
Public Const shup As Integer = 210
Public Const shdn As Integer = 211
Public Const shdx As Integer = 212
Public Const shsx As Integer = 213
Public Const Fixed As Integer = 216
Public Const Kills As Integer = 220
Public Const Repro As Integer = 300
Public Const mrepro As Integer = 301
Public Const sexrepro As Integer = 302
Public Const energy As Integer = 310
Public Const BODY As Integer = 311
Public Const fdbody As Integer = 312
Public Const strbody As Integer = 313
Public Const setboy As Integer = 314
Public Const rdboy As Integer = 315
Public Const mtie As Integer = 330
Public Const stifftie As Integer = 331
Public Const mkvirus As Integer = 335
Public Const DnaLenSys As Integer = 336
Public Const Vtimer As Integer = 337
Public Const VshootSys As Integer = 338
Public Const GenesSys As Integer = 339
Public Const DelgeneSys As Integer = 340
Public Const thisgene As Integer = 341
Public Const LandM As Integer = 400
Public Const trefbody As Integer = 437
Public Const trefxpos As Integer = 438
Public Const trefypos As Integer = 439
Public Const trefvelmysx As Integer = 440
Public Const trefvelmydx As Integer = 441
Public Const trefvelmydn As Integer = 442
Public Const trefvelmyup As Integer = 443
Public Const trefvelscalar As Integer = 444
Public Const trefvelyoursx As Integer = 445
Public Const trefvelyourdx As Integer = 446
Public Const trefvelyourdn As Integer = 447
Public Const trefvelyourup As Integer = 448
Public Const trefshell As Integer = 449
Public Const tieport1 As Integer = 450
Public Const tieloc As Integer = 452
Public Const tieval As Integer = 453
Public Const tienum As Integer = 455
Public Const trefnrg As Integer = 456
Public Const EyeStart As Integer = 500
Public Const EyeEnd As Integer = 510
Public Const refmulti = 686
Public Const refshell = 687
Public Const refbody = 688
Public Const refxpos = 689
Public Const refypos = 690
Public Const refvelscalar As Integer = 695
Public Const refvelsx As Integer = 696
Public Const refveldx As Integer = 697
Public Const refveldn As Integer = 698
Public Const refvelup As Integer = 699
Public Const occurrstart As Integer = 700
Public Const out1 As Integer = 800
Public Const out2 As Integer = 801
Public Const in1 As Integer = 810
Public Const in2 As Integer = 811
Public Const poison As Integer = 827
Public Const backshot As Integer = 900
Public Const aimshoot As Integer = 901

' robot structure
Private Type robot

  Exist As Boolean        ' the robot exists?
  radius As Single
  Shape As Integer        ' shape of the robot, how many sides
  
  Veg As Boolean          ' is it a vegetable?
  
  Wall As Boolean         ' is it a wall?
  Corpse As Boolean
  Fixed As Boolean        ' is it blocked?
  
  ' physics
  pos As vector
  BucketPos As vector
  EnvPos As vector
  
  vel As vector
   
  ForceInd As vector      ' independant forces vector
  ForceRes As vector      ' Resistive forces vector
  ForceStatic As Single   ' static force scalar (always opposes current forces)
    
  MaxSpeed As Integer     'set to 60
  AddedMass As Single     'From fluid displacement
  
  aim As Single           ' aim angle
  aimvector As vector     ' the unit vector for aim
  
  oaim As Single          ' old aim angle
  ma As Single              ' angular momentum
  mt As Single              ' torch
  absvel As Long            ' absolute speed
  Ties(10) As tie           ' array of ties
  order As Integer          'order in the roborder array
    
  occurr(20) As Integer     ' array with the ref* values
  nrg As Single             ' energy
  onrg As Single            ' old energy
  
  BODY As Single            ' Body points. A corpse still has a body after all
  obody As Single           ' old body points, for use with pain pleas versions for body
  vbody As Single           ' Virtual Body used to calculate body functions of MBs
    
  mass As Single            ' mass of robot
  
  Shell As Single          ' Hard shell. protection from shots 1-100 reduces each cycle
  Slime As Single          ' slime layer. protection from ties 1-100 reduces each cycle
  Waste As Single          ' waste buildup in a robot. Too much and he dies. some can be removed by various methods
  Pwaste As Single         ' Permanent waste. cannot be removed. Builds up as waste is removed.
  poison As Single         ' How poisonous is robot
  venom As Single          ' How venomous is robot
    
  Paralyzed As Boolean      ' true when robot is paralyzed
  Paracount As Single       ' countdown until paralyzed robot is free to move again
  
  Numties As Single         ' the number of ties attached to a robot
  Multibot As Boolean       ' Is robot part of a multi-bot
  
  Poisoned As Boolean       ' Is robot poisoned and confused
  Poisoncount As Single     ' Countdown till poison is out of his system
  
  Bouyancy As Single        ' Does robot float or sink
  DecayTimer As Integer     ' controls decay cycle
  Kills As Long             ' How many other robots has it killed? Might not work properly
  Dead As Boolean           ' Allows program to define a robot as dead after a certain operation
  Ploc As Integer           ' Location for custom poison to strike
  Vloc As Integer           ' Location for custom venom to strike
  Vval As Integer           ' Value to insert into venom location
  Vtimer As Integer         ' Count down timer to produce a virus
  
  vars(50) As var           '|
  vnum As Integer           '| about private variables
  maxusedvars As Integer    '|
  usedvars(1000) As Integer  '| used memory cells
  
  ' virtual machine
  pntr As Integer           ' instruction pointer
  mem(1000) As Integer      ' memory array
  DNA() As block            ' program array
  condlist(1000) As Integer ' conditions pointer
  
  lastopp As Long        ' last robot in eye5
  lastviewed As Long
  MinEYE As Integer
  MinEyeSlope As Single
  MinEyeBottomQuadrants As Boolean
   
  view As Boolean           ' robot has ever used eyes? (to save computation time)
  AbsNum As Long            ' absolute robot number
  
  'Mutation related
  Mutables As mutationprobs
  'mutarray(20) As Long      ' mutation rates array
  'Mutation As Boolean       ' Enables or Disables mutations
  'MutMean(1, 20) As Single
  'MutStdDev(1, 20) As Single
  'IsLinear(1, 20) As Boolean
  
  PointMutCycle As Long     ' Next cycle to point mutate (expressed in cycles since birth.  ie: age)
  PointMutBP As Long        ' the base pair to mutate
  
  condnum As Integer        ' number of conditions (used for cost calculations)
  console As Consoleform    ' console object associated to the robot
  
  ' informative
  SonNumber As Integer      ' number of sons
  Mutations As Integer      ' total mutations
  LastMut As Integer        ' last mutations
  Parent As Long            ' parent absolute number
  age As Long               ' age in cycles
  BirthCycle As Long        ' birth cycle
  genenum As Integer        ' genes number
  generation As Integer     ' generation
  LastOwner As String       ' last internet owner's name
  fname As String           ' species name
  DnaLen As Integer         ' dna length
  LastMutDetail As String   ' description of last mutations
  
  ' aspetto
  Skin(13) As Integer       ' skin definition
  OSkin(13) As Integer      ' Old skin definition
  color As Long             ' colour
  highlight As Boolean      ' is it highlighted?
  
End Type

Public Badwastelevel As Integer
Public Const RobSize As Integer = 120    ' rob diameter
Public Const half As Integer = 60        ' and so on...
Public Const ShotsLastTime As Integer = 2000 ' default lasting time for shots
Public Const factor As Integer = 800
  'conversion factor from .body to size of robot. Smaller number makes bigger bot
  '533 makes a 32000 body bot twice as large as normal
Public Const CubicTwipPerBody As Long = 905

Public Const RobArrayMax As Integer = 5000
Public rob(RobArrayMax) As robot    ' array of robots
Public rep(RobArrayMax) As Integer  ' array for pointing to robots attempting reproduction
Dim rp As Integer
Public kil(RobArrayMax) As Integer  ' array of robots to kill
Dim kl As Integer
'Public rlist As New list     ' a pointers list to maintain robots ordered along x axis
Public MaxRobs As Integer    ' max used robots array index
Public robfocus As Integer  ' the robot which has the focus (selected)
Public TotalRobots As Integer  ' total robots in the sim
Public AbsNum As Long          ' robots born (used to assign unique code)
Public MaxMem As Integer

Const SlimeCost As Integer = 1 'cost per unit of shell
Const ShellCost As Integer = 1 'cost per unit of slime

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  R O B O T S    M A N A G E M E N T
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Function FindRadius(ByVal bodypoints As Single) As Single
  If bodypoints < 1 Then bodypoints = 1
  FindRadius = (bodypoints * CubicTwipPerBody * 3 / 4 / PI) ^ (1 / 3)
End Function

' returns an absolute acceleration, given up-down,
' left-right values and aim
Public Function absx(aim As Single, ByVal up As Integer, ByVal dn As Integer, ByVal sx As Integer, ByVal dx As Integer) As Integer
  On Error Resume Next
  up = up - dn
  sx = sx - dx
  absx = Cos(aim) * up + Sin(aim) * sx
End Function

Public Function absy(aim As Single, ByVal up As Integer, ByVal dn As Integer, ByVal sx As Integer, ByVal dx As Integer) As Integer
  On Error Resume Next
  up = up - dn
  sx = sx - dx
  absy = -Sin(aim) * up + Cos(aim) * sx
End Function

Private Function NetForces(n As Integer)
  Dim mag As Single
  Dim sign As Integer
  Dim staticV As vector
  
  'The physics engine breaks apart if bot masses are less than about .1
  
  With rob(n)
  
  AddedMass n 'not really a force, but does effect end net acceleration
  
  PlanetEaters n
  TieHooke n
  FrictionForces n
  SphereDragForces n
  'CylinderDragForces n 'I give up!  It's impossible!
  
  BrownianForces n
  BouyancyForces n
  GravityForces n
  GateForces n
  VoluntaryForces n
  
  bordercolls n
  Colls2 n
  
  If .ForceStatic > 0 Then
    staticV = VectorScalar(VectorUnit(.ForceInd), .ForceStatic)
    If VectorInvMagnitude(staticV) > VectorInvMagnitude(.ForceInd) Then
      .ForceInd = VectorSub(.ForceInd, staticV)
    End If
  End If
  
  .ForceInd = VectorSub(.ForceInd, .ForceRes)
  End With
End Function

Private Sub AddedMass(n As Integer)
  'added mass is a simple enough concept.
  'To move an object through a liquid, you must also move
  'that liquid out of the way.
  
  Const fourthirdspi As Single = 4.18879
  
  Const AddedMassCoefficientForASphere As Single = 0.5
  
  With rob(n)
    .AddedMass = AddedMassCoefficientForASphere * _
      SimOpts.Density * fourthirdspi * .radius * .radius * .radius
  End With
End Sub

Private Sub FrictionForces(n As Integer)
  Dim Force As Single
  Dim mag As Single
  With rob(n)
  
  If SimOpts.Zgravity = 0 Then Exit Sub
  
  If .vel.x = 0 And .vel.y = 0 Then 'is there a vector way to do this?
    .ForceStatic = .mass * SimOpts.Zgravity * SimOpts.CoefficientStatic
  Else
    Force = .mass * SimOpts.Zgravity * SimOpts.CoefficientKinetic
    .ForceRes = VectorScalar(VectorUnit(.vel), Force)
  End If
  End With
End Sub

Private Sub BrownianForces(n As Integer)
  If SimOpts.PhysBrown = 0 Then Exit Sub
  
  With rob(n)
    .ForceInd.x = .ForceInd.x + Random(-SimOpts.PhysBrown / 2, SimOpts.PhysBrown / 2)
    .ForceInd.y = .ForceInd.y + Random(-SimOpts.PhysBrown / 2, SimOpts.PhysBrown / 2)
  End With
End Sub

Private Sub SphereDragForces(n As Integer) 'for bots
  Dim Force As Single
  Dim ForceVector  As vector
  Dim mag As Single
  
  If rob(n).vel.x = 0 And rob(n).vel.y = 0 Then Exit Sub
  
  mag = VectorMagnitude(rob(n).vel)
  
  Force = 0.5 * SphereCd(mag, rob(n).radius) * _
    SimOpts.Density * mag * mag * (PI * rob(n).radius ^ 2)
  ForceVector = VectorScalar(VectorUnit(rob(n).vel), Force)
  rob(n).ForceRes = VectorAdd(rob(n).ForceRes, ForceVector)
End Sub

Private Sub CylinderDragForces(n As Integer) 'for ties
'calculate drag on the ties as if the ties are cylinders
'radius of the tie should be stored in tie array
Dim A As Long

For A = 0 To 10
  If rob(n).Ties(A).pnt > 0 Then
    'If rob(n).Ties(a).pnt > n Then TieDrag2 n, rob(n).Ties(a).pnt
    TieDrag3 n, rob(n).Ties(A).pnt
  End If
Next A

End Sub

Private Sub TieDrag3(n1 As Integer, N2 As Integer)
  Dim pos As vector
  Dim A As Single, b As Single, c As Single
  Dim TorqueScalar
  
  pos = VectorSub(rob(N2).pos, rob(n1).pos)
  
  A = Cross(rob(n1).vel, pos)
  b = Cross(rob(N2).vel, pos)
  c = (A + b) * 0.5 * 0.0001
  
  'pretend Cd is always 1
  pos = VectorUnit(pos)
  pos = VectorSet(-pos.y, pos.x)
  rob(n1).ForceRes = VectorSub(rob(n1).ForceRes, VectorScalar(pos, Abs(c)))
  
End Sub

Private Sub TieDrag2(ByVal n1 As Long, ByVal N2 As Long)
  Dim pos As vector
  Dim A As Single, b As Single, c As Single
  Dim invlength As Single
  Dim ForceScalar As Single
  
  If rob(n1).mass = 0 Or rob(N2).mass = 0 Then Exit Sub
  
  'cooperative or independant\
  pos = VectorSub(rob(n1).pos, rob(N2).pos)
  invlength = VectorInvMagnitude(pos)
  
  'a and b are the two cross velocities
  A = Cross(rob(n1).vel, pos)
  b = Cross(rob(N2).vel, pos)
  
  c = (A + b) * 0.5 * invlength 'the average cross velocity
  'use c to find the Cd
  
  Dim asquare As Single
  Dim ab As Single
  Dim bsquare As Single
  Dim BigB As Single
  Dim BigA As Single
  Const TieRadius As Single = 30
  
  asquare = A * A
  ab = A * b
  bsquare = b * b
  BigB = rob(N2).mass / (rob(n1).mass + rob(N2).mass)
  BigA = SimOpts.Density * TieRadius * CylinderCd(c, TieRadius) * 0.083333333333 * Sgn(c)
  
  ForceScalar = BigA * invlength * (4 * BigB * _
    (asquare - 5 * ab + bsquare) + asquare + 2 * ab + 3 * bsquare)
  'divide the above be either B or 1-B (depending on which robot we're
  'applying forces to) and multiply by the orthogonal unit component to pos
  pos = VectorScalar(pos, invlength)
  pos = VectorSet(-pos.y, pos.x)
  
  rob(n1).ForceRes = VectorAdd(rob(n1).ForceRes, _
    VectorScalar(pos, ForceScalar * 0.5 / BigB))
  'rob(N2).ForceRes = VectorAdd(rob(N2).ForceRes, _
  '  VectorScalar(pos, ForceScalar * 0.5 / (1 - BigB)))
End Sub

Private Sub TieDrag(n1 As Integer, N2 As Integer)
'Simple method:
'assumes a linear relationship between velocity and drag (which isn't always the case,
'but hopefully we're in the right neighborhood):

'v1 = my velocity
'm1 = my mass
'p1 = my position
'v2 = other 's velocity
'm2 = other mass
'p2 = other position
'
'
'1.  Find unit vector for tie = u = (p2 - p1) / length(p2-p1)
'2.  Vc = velocity of Mc = (m1v1+m2v2)/(m1+m2)
'3.  a = v1 cross u  |  a and b are the cross velocities, that is, the velocity
'    b = vc cross u  |  perpindicular to the movement of the tie,
'                    |  which is the direction that causes drag
'    c = (a + b) / 2
'4.  Find force of drag per unit length using c as the velocity <--- this is
'     the assumption that drag and velocity are linearly related.
'     For turbulent flows, using the average of two velocities is incorrect.
'     In the future, this should be solved.  This requires integrating the
'     Cd and drag force equations for length (with velocity depending linearly
'     on distance from either Mc or m1 of course) between 0 and distance from
'     m1 to Mc.
'5.  The torque (we just add it to resistive forces) applied to "me" =
'     Drag Force per length / 2, since it's the area of the triangle
'     formed by length and dragforces at Mc and m1, divided by the length
'     since we 're applying them all to m1.

Dim u As vector, vc As vector, A As Single, b As Single, c As Single
Dim DragScalar As Single
Dim Drag As vector

'1.  Find unit vector
u = VectorUnit(VectorSub(rob(N2).pos, rob(n1).pos))

'2 Vc:
vc = VectorAdd(VectorScalar(rob(n1).vel, rob(n1).mass), _
      VectorScalar(rob(N2).vel, rob(N2).mass))
vc = VectorScalar(vc, rob(n1).mass + rob(N2).mass)

'3.  the a,b,c vectors
A = Cross(rob(n1).vel, u)
b = Cross(vc, u)
c = 0.5 * (A + b)

'4.  Find drag using c:

'1.7 is a good radius.  What?  Whhhaaatttt?  It is.
'okay, it's because that's what 10 body, at 905 twips^3 each,
'stretched into a cylinder with a length of 1000 twips would be
DragScalar = SimOpts.Density * 50 * (c * c) '* CylinderCd(c, 50)
Drag = VectorScalar(VectorSet(-u.y, u.x), Sgn(-c) * DragScalar * 0.5)

'5:  apply drag to bot
'not working right :/
rob(n1).ForceRes = VectorAdd(rob(n1).ForceRes, Drag)
End Sub

Private Function SphereCd(ByVal velocitymagnitude As Single, ByVal radius As Single) As Single
  'computes the coeficient of drag for a spehre given the unit reynolds in simopts
  'totally ripped from an online drag calculator.  So sue me.
  
  With SimOpts
  
  Dim Reynolds As Single, y11 As Single, y12 As Single, y13 As Single, y1 As Single, y2 As Single, alpha As Single
  If .Viscosity = 0 Then Exit Function
  Reynolds = radius * 2 * velocitymagnitude * .Density / .Viscosity
  If Reynolds = 0 Then
    SphereCd = 0
    Exit Function
  End If
  
  y11 = 24 / (3 * 10 ^ 5)
  y12 = 6 / (1 + Sqr(3 * 10 ^ 5))
  y13 = 0.4
  
  y1 = y11 + y12 + y13
  y2 = 0.09
  
  alpha = (y2 - y1) * 50000 ^ -2

  If Reynolds < 3 * 10 ^ 5 Then
    SphereCd = 24 / Reynolds + 6 / (1 + Sqr(Reynolds)) + 0.4
  ElseIf Reynolds < 3.5 * 10 ^ 5 Then
    SphereCd = alpha * (Reynolds - (3 * 10 ^ 5)) ^ 2 + y1
  ElseIf Reynolds < 6 * 10 ^ 5 Then
    SphereCd = 0.09
  ElseIf Reynolds < 4 * 10 ^ 6 Then
    SphereCd = (Reynolds / (6 * 10 ^ 5)) ^ 0.55 * y2
  Else
    SphereCd = 0.255
  End If
  End With
End Function

Private Function CylinderCd(ByVal velocitymagnitude As Single, ByVal radius As Single) As Single
  Dim sign As Single
  
  With SimOpts
  
  Const alpha As Single = -3.6444444444444E-11
  
  If velocitymagnitude < 0 Then
    sign = -1#
    velocitymagnitude = -velocitymagnitude
  Else
    sign = 1#
  End If
  
  If .Viscosity = 0 Then
    CylinderCd = 0
    Exit Function
  End If
  
  Dim Reynolds As Single
  Reynolds = radius * 2 * velocitymagnitude * .Density / .Viscosity
  
  Select Case Reynolds
    Case 0
      CylinderCd = 0
    Case Is < 1
      CylinderCd = (8 * PI) / (Reynolds * (Log(8 / Reynolds) - 0.077216))
    Case Is < 100000#
      CylinderCd = 1 + 10 / Reynolds ^ (2 / 3)
    Case Is < 250000#
      CylinderCd = alpha * (Reynolds - 100000) ^ 2 + 1#
    Case Is < 600000#
      CylinderCd = 0.18
    Case Is < 4000000
      CylinderCd = 0.18 * (Reynolds / 600000) ^ 0.63
    Case Is >= 4000000
      CylinderCd = 0.6
  End Select
  End With
End Function

Private Sub BouyancyForces(n As Integer)
  Dim Force As Single
  With rob(n)
    If SimOpts.Ygravity = 0 Then Exit Sub
    
    Force = -SimOpts.Density * .radius ^ 3 * 4 / 3 * PI * SimOpts.Ygravity
    .ForceInd = VectorAdd(.ForceInd, VectorSet(0, Force))
  End With
End Sub

' a little repulsion field around the download gate, just to
' avoid blocking the way to incoming robots
Public Sub GateForces(n As Integer)
If IntOpts.Active = False Then Exit Sub
  Dim xr As Single
  Dim XCenter As Single
  Dim YCenter As Single
  Dim radius As Single
  Dim dist As Single
  Dim spx As Single
  Dim spy As Single
  Dim k As node
  
  radius = IntOpts.RUpload / 2
  
  xr = IntOpts.XSpawn + IntOpts.RUpload
  
  XCenter = IntOpts.XSpawn + radius
  YCenter = IntOpts.YSpawn + radius
  
  radius = radius * radius * 2.8 '* 2.8 for the edges of the square
  dist = (rob(n).pos.x - XCenter) ^ 2 + (rob(n).pos.y - YCenter) ^ 2
  
  If dist < radius Then
    spx = -((radius - dist) / radius ^ 2) * 200
    spy = (YCenter - rob(n).pos.y) * spx
    spx = (XCenter - rob(n).pos.x) * spx
    rob(n).ForceInd = VectorSet(spx, spy)
  End If
End Sub

Private Sub GravityForces(n As Integer)
  With rob(n)
    .ForceInd = VectorAdd(.ForceInd, VectorSet(0, SimOpts.Ygravity * .mass))
  End With
End Sub

Private Sub VoluntaryForces(n As Integer)
  'calculates new acceleration and energy values from robot's
  '.up/.dn/.sx/.dx vars
  Dim EnergyCost As Single
  Dim NewAccel As vector
  Dim dir As vector
  
  With rob(n)
    'corpses are dead, they don't move around of their own volition
    If .Corpse Then Exit Sub
    
    'yes it's backwards, that's on purpose
    dir = VectorSet(.mem(dirup) - .mem(dirdn), .mem(dirsx) - .mem(dirdx))
        
    NewAccel = VectorSet(Dot(.aimvector, dir), Cross(.aimvector, dir))
    .ForceInd = VectorAdd(.ForceInd, VectorScalar(NewAccel, SimOpts.PhysMoving))
    
    EnergyCost = VectorMagnitude(NewAccel)
    If .Multibot Then EnergyCost = EnergyCost / (.Numties + 1)
    .nrg = .nrg - EnergyCost
  End With
End Sub

Private Sub TieHooke(n As Integer, Optional timestep As Single = 0)
  'Handles Hooke forces of a tie.  That is, stretching and shrinking
  'Force = -kx - bv
  'from experiments, k and b should be less than .1 otherwise the forces
  'become too great for a euler modelling (that is, the forces become too large
  'for velocity = velocity + acceleration
  
  'can be made less complex (from O(n^2) to Olog(n) by calculating forces only
  'for robots less than current number and applying that force to both robots
    
  Dim length As Single
  Dim displacement As Single
  Dim Force As Single
  Dim k As Integer
  Dim uv As vector
  Dim vy As vector
  
  With rob(n)
        
  For k = 1 To 10
    
    'burn through empty slots in case one is hiding
    While k <= 10 And .Ties(k).pnt <= 0
      k = k + 1
      If k > 10 Then Exit Sub
    Wend
    
    uv = VectorSub(.pos, rob(.Ties(k).pnt).pos)
    length = VectorInvMagnitude(uv)
                
    .Ties(k).b = 0.01
    .Ties(k).k = 0.005
    
    'update ties
    'remember length is inverse squareroot
    'If length < .001 Then deltie n, .Ties(k).pnt
    If .Ties(k).last > 1 Then .Ties(k).last = .Ties(k).last - 1
    If .Ties(k).last = 1 Then deltie n, .Ties(k).pnt
    
    If length <> 0 Then
      uv = VectorScalar(uv, length)
      
      'first -kx
      displacement = .Ties(k).NaturalLength - 1 / length
      Force = .Ties(k).k * displacement
      .ForceInd = VectorAdd(.ForceInd, VectorScalar(uv, Force))
      
      'next -bv
      vy = VectorSub(.vel, rob(.Ties(k).pnt).vel)
      Force = -Dot(vy, uv) * .Ties(k).b
      .ForceInd = VectorAdd(.ForceInd, VectorScalar(uv, Force))
    End If
  Next k
  End With
End Sub

Private Sub PlanetEaters(n As Integer)
  Dim t As Integer
  Dim Force As Single
  Dim PosDiff As vector
  Dim mag As Single
  
  If Not SimOpts.PlanetEaters Then Exit Sub
  If rob(n).mass = 0 Then Exit Sub
    
  For t = n + 1 To MaxRobs
    If rob(t).mass = 0 Or Not rob(t).Exist Then GoTo Nextiteration
    PosDiff = VectorSub(rob(t).pos, rob(n).pos)
    mag = VectorMagnitudeSquare(PosDiff)
    If mag = 0 Then GoTo Nextiteration
    
    Force = (SimOpts.PlanetEatersG * rob(n).mass * rob(t).mass) / (mag)
    
    PosDiff = VectorScalar(VectorUnit(PosDiff), Force)
    rob(n).ForceInd = VectorAdd(rob(n).ForceInd, PosDiff)
    rob(t).ForceInd = VectorSub(rob(t).ForceInd, PosDiff)
Nextiteration:
  Next t
End Sub

Private Function SetAimFunc(t As Integer) As Single
  'ByVal aim As Single, ByVal sx As Long, ByVal dx As Long, Optional ByVal setittothis As Single = 32000) As Single
  With rob(t)
  If .mem(SetAim) = 32000 Then
    SetAimFunc = (.aim * 200 + .mem(aimsx) - .mem(aimdx))
  Else
    SetAimFunc = .mem(SetAim)
  End If
  
  SetAimFunc = SetAimFunc Mod (1256)
  If SetAimFunc < 0 Then SetAimFunc = SetAimFunc + 1256
  SetAimFunc = SetAimFunc / 200
  
  .aim = SetAimFunc
  .aimvector = VectorSet(Cos(.aim), Sin(.aim))
  End With
End Function

' updates positions, transforming calculated accelerations
' in velocities, and velocities in new positions
Public Sub UpdatePosition(ByVal n As Integer)
  Dim t As Integer
  Dim vt As Single
  
  With rob(n)
  
  If Not .Fixed Then
    ' speed normalization
    If .mass > 0 Then
      .vel = VectorAdd(.vel, VectorScalar(.ForceInd, 1 / (.mass + .AddedMass)))
    End If
        
    .ForceInd = VectorSet(0, 0)
    .ForceRes = .ForceInd
    .ForceStatic = 0
    
    vt = VectorMagnitudeSquare(.vel)
    If vt > .MaxSpeed * .MaxSpeed Then
      .vel = VectorScalar(VectorUnit(.vel), .MaxSpeed)
      vt = .MaxSpeed
    End If
    
    .pos = VectorAdd(.pos, .vel)
  End If
  
  UpdateBotBucket n
  ' if it's time, sends a robot on the net
  If IntOpts.Active And IntOpts.LastUploadCycle = 0 Then VerificaPosizione n
  
  .mem(dirup) = 0
  .mem(dirdn) = 0
  .mem(dirdx) = 0
  .mem(dirsx) = 0
  
  .mem(velscalar) = vt
  .mem(vel) = Cos(.aim) * .vel.x + Sin(.aim) * .vel.y * -1
  .mem(veldn) = .mem(vel) * -1
  .mem(veldx) = Sin(.aim) * .vel.x + Cos(.aim) * .vel.y
  .mem(velsx) = .mem(veldx) * -1
  
  If SimOpts.ZeroMomentum = True Then .vel = VectorSet(0, 0)
  End With
End Sub

Private Sub makeshell(n)
Dim oldshell As Integer
Dim cost As Single
    With rob(n)
        oldshell = .Shell
        .Shell = .Shell + .mem(822)
        If .Shell > 32000 Then .Shell = 32000
        If .Shell < 1 Then .Shell = 1
        cost = (.Shell - oldshell) * ShellCost
        If cost < 0 Then cost = 0
        .nrg = .nrg - cost / (.Numties + 1)
        .Waste = .Waste + cost / 10
        .mem(822) = 0
    End With
End Sub
Private Sub makeslime(n)
Dim oldslime As Integer
Dim cost As Single
  With rob(n)
    oldslime = .Slime
    .Slime = .Slime + .mem(820)
    If .Slime > 32000 Then .Slime = 32000
    If .Slime < 0 Then .Slime = 0
    cost = (.Slime - oldslime) * SlimeCost
    If cost < 0 Then cost = 0
    .nrg = .nrg - cost / (.Numties + 1) 'lower cost for multibot
    .Waste = .Waste + cost / 10
    .mem(820) = 0
  End With
End Sub
Private Sub altzheimer(n As Integer) 'makes robots with high waste act in a bizarre fashion. Also a small chance of random death
  Dim loc As Integer, val As Integer
  Dim loops As Integer
  Dim t As Integer
  loops = (rob(n).Pwaste + rob(n).Waste - Badwastelevel) / 4
  With rob(n)
  For t = 1 To loops
    loc = Int(Rnd * 1000) + 1
    val = Int(Rnd * 32000)
    .mem(loc) = val
  Next t
  End With
End Sub

Private Sub UpdateMemsPre(n As Integer)
  Dim t As Integer
  
  With rob(n)
        
  If .Paralyzed Then .mem(.Vloc) = .Vval
  If .Poisoned Then .mem(.Ploc) = 0
  
  If Not (.mem(471) <> 0 And .Numties > 0) Then
    If .mem(472) <> 0 Then   'resets all trefvars to zero if no readtie statement is used
      For t = 456 To 465
        .mem(t) = 0
      Next t
      .mem(472) = 0   'Trefbody
      .mem(475) = 0   'tmemval
      .mem(476) = 0   'tmemloc
      .mem(478) = 0   'treffixed
      For t = 0 To 10 'For trefvelX functions. New from Numsgil
        .mem(trefxpos + t) = 0
      Next t
    End If
  End If
  
  .mass = (.BODY / 1000) + (.Shell / 200) 'set value for mass
  .MaxSpeed = 60
  .mem(masssys) = .mass
  .mem(maxvelsys) = .MaxSpeed
  .lastopp = 0
  End With
End Sub

Private Sub UpdateMemsDuring(n As Integer)
  With rob(n)
    .mem(aimsx) = 0
    .mem(aimdx) = 0
  
    .obody = .mem(BODY)      'replaces routine above
    If .BODY > 32000 Then .BODY = 32000
    .radius = FindRadius(.BODY)
    If .Wall Then .BODY = 1
    .mem(BODY) = .BODY
  
    .mem(AimSys) = .aim * 200
  End With
End Sub

Public Function genelength(n As Integer, p As Integer)
  'measures the length of gene p in robot n
  Dim k As Integer, genes As Long
  Dim i As Integer
  Dim f As Integer
  
  k = 1
  With rob(n)
  While True
    If .DNA(k).tipo = 10 And .DNA(k).value = 1 Then Exit Function
    
    If .DNA(k).tipo = 9 And .DNA(k).value <> 1 And .DNA(k).value <> 4 Then
      genes = genes + 1
    End If
    
    If genes = p Then
      i = PrevStop(rob(n).DNA, k)
      f = NextStop(rob(n).DNA, k)
      genelength = f - i
    End If
    k = k + 1
  Wend
  End With
End Function

Private Sub BotDNAManipulation(n As Integer)
  With rob(n)
  
  'Viruses
  If .mem(mkvirus) > 0 And .Vtimer = 0 Then .Vtimer = genelength(n, .mem(mkvirus)) * 2
  If .Vtimer > 1 Then .Vtimer = .Vtimer - 1
  .mem(Vtimer) = .Vtimer
  If .mem(VshootSys) > 0 And .Vtimer = 1 Then
    Vshoot n
    .mem(VshootSys) = 0
    .mem(Vtimer) = 0
    .mem(mkvirus) = 0
    .Vtimer = 0
  End If
  
  'Other stuff
  .mem(DnaLenSys) = .DnaLen
  .mem(GenesSys) = CountGenes(.DNA)
  If .mem(DelgeneSys) > 0 Then
    delgene n, .mem(DelgeneSys)
    .mem(DelgeneSys) = 0
  End If
  
  End With
End Sub

Private Sub Poisons(n As Integer)
  With rob(n)
  'Paralyzed means venomized
  If .Paralyzed Then
    .Paracount = .Paracount - 1
    .mem(837) = .Paracount
    If .Paracount < 1 Then .Paralyzed = False: .Vloc = 0: .Vval = 0
  End If

  If .Poisoned Then
    .Poisoncount = .Poisoncount - 1
    .mem(838) = .Poisoncount
    If .Poisoncount < 1 Then .Poisoned = False: .Ploc = 0: .Poisoncount = 0
  End If
  End With
End Sub

Private Sub UpdateCounters(n As Integer)
  With rob(n)
    TotalRobots = TotalRobots + 1
      If .Veg Then
        totvegs = totvegs + 1
      ElseIf .Corpse Then
        totcorpse = totcorpse + 1
        Decay n
      ElseIf .Wall Then
      Else
        totnvegs = totnvegs + 1
      End If
  End With
End Sub

Private Sub ConditionsCharge(n As Integer)
  With rob(n)
  .nrg = .nrg - (SimOpts.CostExecCond * .condnum) / (.Numties + 1) 'cheaper costs for multibots
  End With
End Sub

Private Sub MakeStuff(n As Integer)
  With rob(n)
  
  If .mem(824) <> 0 Then storevenom n
  If .mem(826) <> 0 Then storepoison n
  If .mem(822) <> 0 Then makeshell n
  If .mem(820) <> 0 Then makeslime n
  .Slime = .Slime - .Slime / 50
  If .Shell < 0 Then .Shell = 0
  If .Slime < 0 Then .Slime = 0
  .mem(821) = .Slime
  .mem(823) = .Shell
  End With
End Sub

Private Sub HandleWaste(n As Integer)
  With rob(n)
    If .Waste > 0 And .Veg Then feedveg2 n
    If Badwastelevel = 0 Then Badwastelevel = 400
    If Badwastelevel <> -1 And .Pwaste + .Waste > Badwastelevel Then altzheimer n
    If .Waste > 32000 Then defacate n
    If .Pwaste > 32000 Then .Pwaste = 32000
    If .Waste < 0 Then .Waste = 0
    .mem(828) = .Waste
    .mem(829) = .Pwaste
  End With
End Sub

Private Sub Ageing(n As Integer)
  With rob(n)
    'aging
    .age = .age + 1: If .age > 32000 Then .age = 32000
    .mem(robage) = .age        'line added to copy robots age into a memory location
  End With
End Sub

Private Sub Shooting(n As Integer)
  'shooting
  If rob(n).mem(shoot) Then robshoot n
  rob(n).mem(shoot) = 0
End Sub

Private Sub ManageBody(n As Integer)
  With rob(n)
  'body management
  If .mem(strbody) > 0 Then storebody n
  If .mem(fdbody) > 0 Then feedbody n
  .radius = FindRadius(.BODY)
  End With
End Sub

Private Sub Shock(n As Integer)
  With rob(n)
  'shock code:
  'later make the shock threshold based on body and age
  If Not .Veg And .nrg > 3000 Then
    Dim temp As Long
    temp = .onrg - .nrg
    If temp > (.onrg / 2) Then
      .nrg = 0
      .BODY = .BODY + (.nrg / 10)
      .radius = FindRadius(.BODY)
      If .BODY > 32000 Then .BODY = 32000
    End If
  End If
  End With
End Sub

Private Sub ManageDeath(n As Integer)
  With rob(n)
  If .nrg < 1 And Not SimOpts.CorpseEnabled Then
        .Dead = True
      End If
      If SimOpts.CorpseEnabled Then
        If Not .Corpse Then
          If .nrg < 1 And .age > 1 Then
            .Corpse = True
            .view = False
            .fname = "Corpse"
            delallties n
            .color = vbWhite
            .Veg = False
            .Fixed = False
            If SimOpts.Bouyancy Then .Bouyancy = -1.5
          End If
        End If
        If .Corpse = True Then
          .nrg = 0
        End If
      Else
        If .nrg < 1 Then
          .Dead = True
        End If
      End If
  
  If .BODY < 1 Then .Dead = True
  
  If .Dead Then
    kil(kl) = n
    kl = kl + 1
  End If
  End With
End Sub

Private Sub ManageBouyancy(n As Integer)
  With rob(n)
    'Bouyancy
    'obsolete, so how to fix?
    If .mem(setboy) > 2000 Or .mem(setboy) < -2000 Then .mem(setboy) = 2000 * Sgn(.mem(setboy))
    If SimOpts.Bouyancy Then
       .Bouyancy = .mem(setboy) / 1000
    Else
        .Bouyancy = 0
    End If
    .mem(rdboy) = .Bouyancy * 1000
  End With
End Sub

Private Sub ManageFixed(n As Integer)
  With rob(n)
  'Fixed/ not fixed
        If .mem(216) > 0 Then
          .Fixed = True
          .vel = VectorSet(0#, 0#)
        Else
          .Fixed = False
        End If
  End With
End Sub

Private Sub ManageReproduction(n As Integer)
  With rob(n)
  If .mem(Repro) > 0 Or .mem(mrepro) > 0 Then
    rep(rp) = n
    rp = rp + 1
  End If
        
  If .mem(sexrepro) > 0 Then
    If Not .view Then BucketsProximity n, 4
    If .lastopp > 0 And rob(.lastopp).mem(sexrepro) > 0 Then
      rep(rp) = -n
      rep(rp + 1) = -.lastopp
      rp = rp + 2
    End If
  End If
  End With
End Sub

Private Sub FireTies(n As Integer)
  With rob(n)
  If .mem(mtie) > 0 Then
    BucketsProximity n, 5
    If .lastopp > 0 And Not SimOpts.DisableTies Then
      'maketie auto deletes existing ties for you
      maketie n, rob(n).lastopp, rob(n).radius + rob(rob(n).lastopp).radius + RobSize * 2, -20, rob(n).mem(mtie)
    End If
    .mem(mtie) = 0
  End If
  End With
End Sub

'The heart of the robots to simulation interfacing
Public Sub UpdateBots()
  Dim t As Integer
  Dim k As Integer
  Dim c As Integer
  Dim z As Integer
  Dim q As Integer
  Dim ti As Single
  Dim x As Integer

  rp = 1
  kl = 1
  kil(1) = 0
  rep(1) = 0
  TotalEnergy = 0
  totwalls = 0
  totcorpse = 0
  TotalRobots = 0
  totnvegs = 0
  totvegs = 0
  
  If ContestMode Then
    F1count = F1count + 1
    If F1count = SampFreq And Contests <= Maxrounds Then Countpop
  End If
  
  'this loops if for pre update
  For t = 1 To MaxRobs
    If rob(t).Exist Then
    EraseSenses t
    NetForces t 'calculate forces on all robots
    tieportcom t 'transfer data through ties
    readtie t 'reads all of the tref variables from a given tie number
    UpdateMemsPre t
    UpdateCounters t
    End If
  Next t
  DoEvents
  
  For t = 1 To MaxRobs
    With rob(t)
    If .Exist Then
    Update_Ties t ' Carries out all tie routines
    SetAimFunc t  'Setup aiming
    BotDNAManipulation t
    UpdatePosition t 'updates robot's position
    ConditionsCharge t
    UpdateMemsDuring t
    End If
    End With
  Next t
  DoEvents
  
  For t = 1 To MaxRobs
    With rob(t)
    If Not .Corpse And Not .Wall And .Exist Then
      MakeStuff t
      HandleWaste t
      Ageing t
      Shooting t
      ManageBody t
      Shock t
      ManageDeath t
      ManageBouyancy t
      ManageFixed t
      ManageReproduction t
      WriteSenses t
      FireTies t
    End If
    End With
  Next t
  DoEvents

  ReproduceAndKill
  
  'restart
  If totnvegs = 0 And RestartMode Then
    totnvegs = 1
    Contests = Contests + 1
    ReStarts = ReStarts + 1
    Form1.StartSimul
  End If
End Sub

Private Sub ReproduceAndKill()
  Dim t As Integer
  
  t = 1
  While t < rp
    If rep(t) > 0 Then
      Reproduce rep(t), rob(rep(t)).mem(Repro) + rob(rep(t)).mem(mrepro)
      rob(rep(t)).mem(Repro) = 0
      rob(rep(t)).mem(mrepro) = 0
    ElseIf rep(t) < 0 Then
      SexReproduce -rep(t), -rep(t + 1)
      rob(-rep(t)).mem(sexrepro) = 0
      rob(-rep(t + 1)).mem(sexrepro) = 0
      t = t + 1
    End If
    t = t + 1
  Wend
  t = 1
  
  'kill robots
  While t < kl
    KillRobot kil(t)
    t = t + 1
  Wend
End Sub

Private Sub storebody(t As Integer)
  If rob(t).mem(313) > 100 Then rob(t).mem(313) = 100
  rob(t).nrg = rob(t).nrg - rob(t).mem(313)
  rob(t).BODY = rob(t).BODY + rob(t).mem(313) / 10
  If rob(t).BODY > 32000 Then rob(t).BODY = 32000
  rob(t).radius = FindRadius(rob(t).BODY)
  rob(t).mem(313) = 0
End Sub
Private Sub feedbody(t As Integer)
  If rob(t).mem(fdbody) > 100 Then rob(t).mem(fdbody) = 100
  rob(t).nrg = rob(t).nrg + rob(t).mem(fdbody)
  rob(t).BODY = rob(t).BODY - rob(t).mem(fdbody) / 10
  If rob(t).nrg > 32000 Then rob(t).nrg = 32000
  rob(t).radius = FindRadius(rob(t).BODY)
  rob(t).mem(fdbody) = 0
End Sub

' here we catch the attempt of a robot to shoot,
' and actually build the shot
Private Sub robshoot(n As Integer)
  Dim sh As Integer
  Dim va As Long
  Dim multiplier As Single
  Dim cost As Long
  Dim rngmultiplier As Single
  Dim valmode As Boolean
  sh = rob(n).mem(shoot)
  va = rob(n).mem(shootval)
   
  If va < 0 Then
    multiplier = 1
    rngmultiplier = -va
  ElseIf va > 0 Then
    multiplier = va
    rngmultiplier = 1
    valmode = True
  Else
    multiplier = 1
    rngmultiplier = 1
  End If
  
  If rngmultiplier > 4 Then
    cost = rngmultiplier
    rngmultiplier = Log(cost / 2) / Log(2)
  ElseIf valmode = False Then
    rngmultiplier = 1
    cost = (SimOpts.CostChem / (rob(n).Numties + 1))
  End If
  
  If multiplier > 4 Then
    cost = multiplier
    multiplier = Log(cost / 2) / Log(2)
  ElseIf valmode = True Then
    multiplier = 1
    cost = (SimOpts.CostChem / (rob(n).Numties + 1))
  End If
  
  If cost > rob(n).nrg And cost > 2 And rob(n).nrg > 2 And valmode Then
    cost = rob(n).nrg
    multiplier = Log(cost) / Log(2)
  End If
  
  If cost > rob(n).nrg And cost > 2 And rob(n).nrg > 2 And Not valmode Then
    cost = rob(n).nrg
    rngmultiplier = Log(cost) / Log(2)
  End If
  
  ''''''''''''''''''''''''''''''''''''''''''''''
  ''''''''''''''''''''''''''''''''''''''''''''''
  ''''''''''''''''''''''''''''''''''''''''''''''
  
  Select Case sh
  Case Is >= -1
    sh = sh Mod MaxMem
    If sh = -1 Then
      If rob(n).Multibot Then
        va = 20 + (rob(n).BODY / 5) * (rob(n).Numties + 1)
      Else
        va = 20 + (rob(n).BODY / 5)
      End If
      va = va * multiplier
      rob(n).nrg = rob(n).nrg - cost
    Else
      rngmultiplier = 1
    End If
    newshot n, sh, va, rngmultiplier
  Case -2
    va = Abs(va)
    If rob(n).nrg < va Then va = rob(n).nrg
    If va = 0 Then va = rob(n).nrg / 100 'default energy shot.  Very small.
    rob(n).nrg = rob(n).nrg - va - SimOpts.CostChem / (rob(n).Numties + 1)
    newshot n, sh, va, 1
  Case -3 'shoot venom
    va = Abs(va)
    If va > rob(n).venom Then va = rob(n).venom
    If va = 0 Then va = rob(n).venom / 20 'default venom shot.  Not too small.
    rob(n).venom = rob(n).venom - va
    rob(n).mem(825) = rob(n).venom
    rob(n).nrg = rob(n).nrg - SimOpts.CostChem / (rob(n).Numties + 1)
    newshot n, sh, va, 1
  Case -4 'shoot waste
    va = Abs(va)
    If va > rob(n).Waste Then va = rob(n).Waste
    rob(n).Waste = rob(n).Waste - va
    If va < 0 Then va = rob(n).Waste / 10 'default waste shot.
    rob(n).Pwaste = rob(n).Pwaste + va / 100
    rob(n).nrg = rob(n).nrg - SimOpts.CostChem / (rob(n).Numties + 1)
    newshot n, sh, va, 1
  ' no -5 shot here as poison can only be shot in response to an attack
  Case -6 'shoot body
    If rob(n).Multibot Then
      va = 10 + (rob(n).BODY / 2) * (rob(n).Numties + 1)
    Else
      va = 10 + Abs(rob(n).BODY) / 2
    End If
    rob(n).nrg = rob(n).nrg - cost
    va = va * multiplier
    newshot n, sh, va, rngmultiplier
  End Select
  rob(n).mem(shoot) = 0
  rob(n).mem(shootval) = 0
End Sub

Public Sub shareslime(t As Integer, k As Integer) 'robot shares slime with others in the same multibot structure
  Dim totslime As Integer
  With rob(t)
    If .mem(833) > 99 Then .mem(833) = 99
    If .mem(833) < 0 Then .mem(833) = 0
    totslime = .Slime + rob(.Ties(k).pnt).Slime
    
    If totslime * (.mem(833) / 100) < 32000 Then
      .Slime = totslime * (.mem(833) / 100)
    Else
      .Slime = 32000
    End If
      If totslime * ((100 - .mem(833)) / 100) < 32000 Then
      rob(.Ties(k).pnt).Slime = totslime * ((100 - .mem(833)) / 100)
    Else
      rob(.Ties(k).pnt).Slime = 32000
    End If
  End With
End Sub
Public Sub sharewaste(t As Integer, k As Integer)
  Dim totwaste As Long
  With rob(t)
    If .mem(831) > 99 Then .mem(831) = 99
    If .mem(831) < 0 Then .mem(831) = 0
    totwaste = .Waste + rob(.Ties(k).pnt).Waste
    
    If totwaste * (.mem(831) / 100) < 32000 Then
      .Waste = totwaste * (.mem(831) / 100)
    Else
      .Waste = 32000
    End If
      If totwaste * ((100 - .mem(831)) / 100) < 32000 Then
      rob(.Ties(k).pnt).Waste = totwaste * ((100 - .mem(831)) / 100)
    Else
      rob(.Ties(k).pnt).Waste = 32000
    End If
  End With
End Sub
Public Sub shareshell(t As Integer, k As Integer)
  Dim totshell As Long
  
  With rob(t)
    If .mem(832) > 99 Then .mem(832) = 99
    If .mem(832) < 0 Then .mem(832) = 0
    totshell = .Shell + rob(.Ties(k).pnt).Shell
    
    If totshell * ((100 - .mem(832)) / 100) < 32000 Then
      rob(.Ties(k).pnt).Shell = totshell * ((100 - .mem(832)) / 100)
    Else
      rob(.Ties(k).pnt).Shell = 32000
    End If
    If totshell * (.mem(832) / 100) < 32000 Then
      .Shell = totshell * (.mem(832) / 100)
    Else
      .Shell = 32000
    End If
  End With
End Sub
Public Sub sharenrg(t As Integer, k As Integer)
  Dim totnrg As Long
  With rob(t)
    If .mem(830) > 99 Then .mem(830) = 99
    If .mem(830) < 0 Then .mem(830) = 0
    totnrg = .nrg + rob(.Ties(k).pnt).nrg
    
    If totnrg * ((100 - .mem(830)) / 100) < 32000 Then
      rob(.Ties(k).pnt).nrg = totnrg * ((100 - .mem(830)) / 100)
    Else
      rob(.Ties(k).pnt).nrg = 32000
    End If
    If totnrg * (.mem(830) / 100) < 32000 Then
      .nrg = totnrg * (.mem(830) / 100)
    Else
      .nrg = 32000
    End If
    
  End With
End Sub

'Robot n converts some of his energy to venom
Public Sub storevenom(n As Integer)
  With rob(n)
    If .mem(824) > .nrg Then .mem(824) = .nrg / 2
    .venom = .venom + .mem(824)
    If .mem(824) > 0 Then
      .nrg = .nrg - .mem(824)
      .Waste = .Waste + .mem(824) / 100
      If .venom > 32000 Then .venom = 32000
    Else
      .Waste = .Waste - .mem(824) / 100
      If .venom < 0 Then .venom = 0
    End If
    .mem(825) = .venom
    .mem(824) = 0
  End With
End Sub
' Robot n converts some of his energy to poison
Public Sub storepoison(n As Integer)
  With rob(n)
    If .mem(826) > .nrg Then .mem(826) = .nrg / 2
    .poison = .poison + .mem(826)
    If .mem(826) > 0 Then
      .nrg = .nrg - .mem(826)
      .Waste = .Waste + .mem(826) / 100
      If .poison > 32000 Then .poison = 32000
    Else
      .Waste = .Waste - .mem(826) / 100
      If .poison < 0 Then .poison = 0
    End If
    .mem(827) = .poison
    .mem(826) = 0
  End With
End Sub

' Reproduction
' makes some tests regarding the available space for
' spawning a new robot, the position (not off the field, nor
' on the internet d/l gate), the energy of the parent,
' then finally copies the dna and most of the two data
' structures (with some modif. - for example generation),
' sends the newborn rob to the mutation division,
' reanalizes the resulting dna (usedvars, condlist, and so on)
' ties parent and son, and the miracle of birth is accomplished
Public Sub Reproduce(n As Integer, per As Integer)
  Dim sondist As Long
  Dim nuovo As Integer
  Dim nnrg As Long, nwaste As Long, npwaste As Long
  Dim nbody As Integer
  Dim nx As Long
  Dim ny As Long
  Dim t As Integer
  Dim tests As Boolean
  tests = False
  
  If n = -1 Then n = robfocus
  
  If rob(n).BODY <= 2 Then Exit Sub 'bot is too small to reproduce
  
  If rob(n).Veg = True And totvegs > SimOpts.MaxPopulation Then
    t = Random(0, totvegs - SimOpts.MaxPopulation)
    totvegs = totvegs + 1
    If t > 0 Then Exit Sub 'attempt to stop veg overpopulation but will it work?
  ElseIf rob(n).Veg = True Then
    totvegs = totvegs + 1
  End If
  
  If per < 1 Then per = 1
  If per > 99 Then per = 99
  sondist = FindRadius(rob(n).BODY * (per / 100)) + FindRadius(rob(n).BODY * ((100 - per) / 100))
  
  nnrg = (rob(n).nrg / 100) * per
  nbody = (rob(n).BODY / 100) * per
  'rob(n).nrg = rob(n).nrg - DNALength(n) * 3
  If rob(n).nrg > 0 Then
    nx = rob(n).pos.x + absx(rob(n).aim, sondist, 0, 0, 0)
    ny = rob(n).pos.y + absy(rob(n).aim, sondist, 0, 0, 0)
    tests = tests Or simplecoll(nx, ny, n)
    tests = tests Or (rob(n).Fixed And IsInSpawnArea(nx, ny))
    If Not tests Then
      nuovo = posto()
      SimOpts.TotBorn = SimOpts.TotBorn + 1
      
      ReDim rob(nuovo).DNA(UBound(rob(n).DNA))
      For t = 1 To UBound(rob(nuovo).DNA)
        rob(nuovo).DNA(t) = rob(n).DNA(t)
      Next t
      
      For t = 1 To rob(n).maxusedvars
        rob(nuovo).usedvars(t) = rob(n).usedvars(t)
      Next t
      
      For t = 0 To 14
        rob(nuovo).Mutables.mutarray(t) = rob(n).Mutables.mutarray(t)
      Next t
      
      rob(nuovo).Mutables.Mutations = rob(n).Mutables.Mutations
      rob(nuovo).Mutations = rob(n).Mutations
      rob(nuovo).LastMut = rob(n).LastMut
      rob(nuovo).LastMutDetail = rob(n).LastMutDetail
      
      For t = 0 To 12
        rob(nuovo).Skin(t) = rob(n).Skin(t)
      Next t
      
      rob(nuovo).maxusedvars = rob(n).maxusedvars
      Erase rob(nuovo).mem
      Erase rob(nuovo).Ties
      
      rob(nuovo).pos.x = rob(n).pos.x + absx(rob(n).aim, sondist, 0, 0, 0)
      rob(nuovo).pos.y = rob(n).pos.y + absy(rob(n).aim, sondist, 0, 0, 0)
      UpdateBotBucket nuovo
      rob(nuovo).vel = rob(n).vel
      rob(nuovo).color = rob(n).color
      rob(nuovo).aim = rob(n).aim + PI
      If rob(nuovo).aim > 6.28 Then rob(nuovo).aim = rob(nuovo).aim - 2 * PI
      rob(nuovo).aimvector = VectorSet(Cos(rob(nuovo).aim), Sin(rob(nuovo).aim))
      rob(nuovo).mem(SetAim) = 32000
      rob(nuovo).mem(468) = 32000
      rob(nuovo).mem(480) = 32000
      rob(nuovo).mem(481) = 32000
      rob(nuovo).mem(482) = 32000
      rob(nuovo).mem(483) = 32000
      rob(nuovo).Exist = True
      rob(nuovo).Corpse = False
      rob(nuovo).Dead = False
      rob(nuovo).generation = rob(n).generation + 1
      rob(nuovo).BirthCycle = SimOpts.TotRunCycle
      rob(nuovo).vnum = 1
      rob(nuovo).pntr = 1
      'rob(nuovo).st.pos = 1
      rob(nuovo).view = False
      nnrg = (rob(n).nrg / 100) * per
      nwaste = rob(n).Waste / 100 * per
      npwaste = rob(n).Pwaste / 100 * per
      rob(n).nrg = rob(n).nrg - nnrg
      rob(n).Waste = rob(n).Waste - nwaste
      rob(n).Pwaste = rob(n).Pwaste - npwaste
      rob(n).BODY = rob(n).BODY - nbody
      rob(n).radius = FindRadius(rob(n).BODY)
      rob(nuovo).BODY = nbody
      rob(nuovo).radius = FindRadius(nbody)
      rob(nuovo).Waste = nwaste
      rob(nuovo).Pwaste = npwaste
      rob(n).mem(energy) = rob(n).nrg
      rob(n).mem(311) = rob(n).BODY
      rob(n).SonNumber = rob(n).SonNumber + 1
      rob(nuovo).nrg = nnrg
      rob(nuovo).onrg = nnrg
      rob(nuovo).mem(energy) = nnrg
      rob(nuovo).Poisoned = False
      rob(nuovo).Parent = rob(n).AbsNum
      rob(nuovo).fname = rob(n).fname
      rob(nuovo).LastOwner = rob(n).LastOwner
      rob(nuovo).Veg = rob(n).Veg
      rob(nuovo).Fixed = rob(n).Fixed
      If rob(nuovo).Fixed Then rob(nuovo).mem(Fixed) = 1
      rob(nuovo).AbsNum = AbsNum
      rob(nuovo).Shape = rob(n).Shape
      BucketsProximity n, 12
      BucketsProximity nuovo, 12
      If rob(n).mem(mrepro) > 0 Then
        For t = 0 To 14
          rob(nuovo).Mutables.mutarray(t) = rob(nuovo).Mutables.mutarray(t) / 10
        Next t
        Mutate nuovo
        For t = 0 To 14
          If rob(nuovo).Mutables.mutarray(t) * 10# <= 32000 Then
            rob(nuovo).Mutables.mutarray(t) = rob(nuovo).Mutables.mutarray(t) * 10
            If rob(nuovo).Mutables.mutarray(t) = 0 Then    'if mrepro then will mutate even if muations are disabled
              rob(nuovo).Mutables.mutarray(t) = 1000
            End If
          Else
            rob(nuovo).Mutables.mutarray(t) = 32000
          End If
        Next t
      Else
        Mutate nuovo
      End If
      
      'If Not CheckIntegrity(rob(nuovo).DNA) Then
      '  'bots are not supposed to die from mutations directly, so don't penalize the parent
      '  rob(n).nrg = rob(n).nrg + rob(nuovo).nrg
      '  rob(n).BODY = rob(n).BODY + rob(nuovo).BODY
      '  rob(nuovo).nrg = 0
      'End If
      
      makeoccurrlist nuovo
      countconditions nuovo
      rob(nuovo).DnaLen = DnaLen(rob(nuovo).DNA())
            
      'maketie n, nuovo, sondist, 100, 0
      rob(n).onrg = rob(n).nrg 'saves parent from dying from shock after giving birth
      rob(nuovo).mass = nbody / 1000 + rob(nuovo).Shell / 200
    End If
  End If
End Sub

' hot hot: sex reproduction
' same as above, but: dna comes from two parents, is crossed-over,
' and the resulting dna is then mutated.
Public Sub SexReproduce(robA As Integer, robB As Integer)
  Dim perA As Integer, perB As Integer
  Dim nrgA As Long, nrgB As Long
  Dim bodyA As Long, bodyB As Long
  Dim sondist As Long
  Dim nuovo As Integer
  Dim nnrg As Long
  Dim nbody As Long
  Dim nx As Long
  Dim ny As Long
  Dim t As Integer
  Dim tests As Boolean
  tests = False
  sondist = RobSize * 1.3
  
  If Sqr((rob(robA).pos.x - rob(robB).pos.x) ^ 2 + (rob(robA).pos.y - rob(robB).pos.y) ^ 2) >= RobSize * 2 Then Exit Sub
  
  perA = rob(robA).mem(sexrepro)
  perB = rob(robB).mem(sexrepro)
  If perA < 1 Then perA = 1
  If perA > 99 Then perA = 99
  If perB < 1 Then perB = 1
  If perB > 99 Then perB = 99
  nrgA = (rob(robA).nrg / 100) * perA
  nrgB = (rob(robB).nrg / 100) * perB
  nnrg = nrgA + nrgB
  If nnrg > 32000 Then
    nnrg = 32000
    nrgA = 32000 * (perA / 100)
    nrgB = 32000 * (perB / 100)
  End If
  bodyA = (rob(robA).BODY / 100) * perA
  bodyB = (rob(robB).BODY / 100) * perB
  nbody = bodyA + bodyB
  If nbody > 32000 Then
    nbody = 32000
    bodyA = 32000 * (perA / 100)
    bodyB = 32000 * (perB / 100)
  End If
  rob(perA).nrg = rob(perA).nrg - rob(robA).DnaLen * 1.5
  rob(perB).nrg = rob(perB).nrg - rob(robB).DnaLen * 1.5
  If rob(perA).nrg > 0 And rob(perB).nrg > 0 Then
    nx = rob(perA).pos.x + absx(rob(perA).aim, sondist, 0, 0, 0)
    ny = rob(perA).pos.y + absy(rob(perA).aim, sondist, 0, 0, 0)
    'tests = tests Or simplecoll(nx, ny, n)
    tests = tests Or (rob(robA).Fixed And IsInSpawnArea(nx, ny))
    If Not tests Then
      nuovo = posto()
      SimOpts.TotBorn = SimOpts.TotBorn + 1
      
      ReDim rob(nuovo).DNA(100)
      
      'Reimplement below!
      
      'DNA is redimed inside a sub function of CrossingOver
      'CrossingOver rob(robA).DNA, rob(robB).DNA, rob(nuovo).DNA
      
      ScanUsedVars nuovo
      For t = 0 To 14
        rob(nuovo).Mutables.mutarray(t) = (rob(robA).Mutables.mutarray(t) + rob(robB).Mutables.mutarray(t)) / 2
      Next t
      If rob(robA).Mutables.Mutations Or rob(robB).Mutables.Mutations Then
        rob(nuovo).Mutables.Mutations = True
      Else
        rob(nuovo).Mutables.Mutations = False
      End If
      For t = 0 To 12
        rob(nuovo).Skin(t) = (rob(robA).Skin(t) + rob(robB).Skin(t)) / 2
      Next t
      Erase rob(nuovo).mem
      Erase rob(nuovo).Ties
      rob(nuovo).pos.x = rob(robA).pos.x + absx(rob(robA).aim, sondist, 0, 0, 0)
      rob(nuovo).pos.y = rob(robA).pos.y + absy(rob(robA).aim, sondist, 0, 0, 0)
      rob(nuovo).vel.x = rob(robA).vel.x
      rob(nuovo).vel.y = rob(robA).vel.y
      rob(nuovo).color = rob(robA).color
      rob(nuovo).aim = rob(robA).aim + PI
      If rob(nuovo).aim > 6.28 Then rob(nuovo).aim = rob(nuovo).aim - 2 * PI
      rob(nuovo).aimvector = VectorSet(Cos(rob(nuovo).aim), Sin(rob(nuovo).aim))
      rob(nuovo).mem(SetAim) = 32000
      rob(nuovo).mem(468) = 32000
      rob(nuovo).mem(480) = 32000
      rob(nuovo).mem(481) = 32000
      rob(nuovo).mem(482) = 32000
      rob(nuovo).mem(483) = 32000
      rob(nuovo).Exist = True
      rob(nuovo).Dead = False
      rob(nuovo).generation = rob(robA).generation + 1
      rob(nuovo).BirthCycle = SimOpts.TotRunCycle
      rob(nuovo).vnum = 1
      rob(nuovo).view = False
      rob(robA).nrg = rob(robA).nrg - nrgA
      rob(robB).nrg = rob(robB).nrg - nrgB
      rob(robA).mem(energy) = rob(robA).nrg
      rob(robB).mem(energy) = rob(robB).nrg
      rob(robA).BODY = rob(robA).BODY - bodyA
      rob(robA).radius = FindRadius(rob(robA).BODY)
      rob(robB).BODY = rob(robB).BODY - bodyB
      rob(robB).radius = FindRadius(rob(robB).BODY)
      rob(robA).mem(315) = rob(robA).BODY
      rob(robB).mem(315) = rob(robB).BODY
      rob(robA).SonNumber = rob(robA).SonNumber + 1
      rob(robB).SonNumber = rob(robB).SonNumber + 1
      rob(nuovo).nrg = nnrg
      rob(nuovo).BODY = nbody
      rob(nuovo).radius = FindRadius(rob(nuovo).BODY)
      rob(nuovo).Poisoned = False
      rob(nuovo).Parent = rob(robA).AbsNum
      rob(nuovo).fname = rob(robA).fname
      rob(nuovo).LastOwner = rob(robA).LastOwner
      rob(nuovo).Veg = rob(robA).Veg
      rob(nuovo).Fixed = rob(robA).Fixed
      If rob(nuovo).Fixed Then rob(nuovo).mem(216) = 1
      rob(nuovo).Corpse = False
      rob(nuovo).Mutations = rob(robA).Mutations
      rob(nuovo).LastMutDetail = rob(robA).LastMutDetail
      rob(nuovo).AbsNum = AbsNum
      rob(nuovo).Shape = rob(robA).Shape
      UpdateBotBucket nuovo
      BucketsProximity robA
      BucketsProximity robB
      BucketsProximity nuovo
      Mutate nuovo
      
      'If Not CheckIntegrity(rob(nuovo).DNA) Then
      '  'parents aren't suposed to be penalized,
      '  'so they need to get their nrg and body back
      '  'NOT YET IMPLEMENTED!
      '  rob(nuovo).nrg = 0
      'End If
      
      makeoccurrlist nuovo
      countconditions nuovo
      rob(nuovo).DnaLen = DnaLen(rob(nuovo).DNA())
      maketie robA, nuovo, RobSize * 1.3, 90, 0
      maketie robB, nuovo, RobSize * 1.3, 90, 0
      
      'to prevent shock
      rob(robA).onrg = rob(robA).nrg
      rob(robB).onrg = rob(robB).nrg
      rob(nuovo).mass = nbody / 1000 + rob(nuovo).Shell / 200
    End If
  End If
End Sub


' verifies rapidly if a field position is already occupied
Public Function simplecoll(x As Long, y As Long, k As Integer) As Boolean
  Dim t As Integer
  Dim radius As Long
  
  simplecoll = False
  
  For t = 1 To MaxRobs
    If rob(t).Exist Then
      If Abs(rob(t).pos.x - x) < rob(t).radius + rob(k).radius And _
        Abs(rob(t).pos.y - y) < rob(t).radius + rob(k).radius Then
        If k <> t Then simplecoll = True
      End If
    End If
  Next t
  
  If SimOpts.Dxsxconnected = False Then
    If x < rob(k).radius + smudgefactor Or x + rob(k).radius + smudgefactor > SimOpts.FieldWidth Then simplecoll = True
  End If
  
  If SimOpts.Updnconnected = False Then
    If y < rob(k).radius + smudgefactor Or y + rob(k).radius + smudgefactor > SimOpts.FieldHeight Then simplecoll = True
  End If
End Function

' searches a free slot in the robots array, to store a new rob
' you may have noticed that the system is hybrid, there's
' a (quadruple) linked list and the array
Public Function posto() As Integer
  Dim t As Integer
  t = 1
  While rob(t).Exist And t <= MaxRobs And t < UBound(rob())
    t = t + 1
  Wend
  
  If t > MaxRobs Then MaxRobs = t
  
  If t = UBound(rob()) Then
    MaxRobs = MaxRobs - 1
    t = t - 1
  End If
  
  posto = t
  rob(0).pos.x = -4000
  AbsNum = AbsNum + 1
  rob(posto).AbsNum = AbsNum
  
  'So there's no chance of inheritance from older bots who left this position open
  rob(posto).absvel = 0
  rob(posto).age = 0
  rob(posto).aim = 0
  rob(posto).aimvector = VectorSet(1, 0)
  rob(posto).BirthCycle = 0 'or the current cycle, whichever
  rob(posto).BODY = 0
  rob(posto).Bouyancy = 0
  rob(posto).color = 0
  Erase rob(posto).condlist()
  rob(posto).condnum = 0
  rob(posto).Corpse = False
  rob(posto).Dead = False
  rob(posto).DecayTimer = 0
  ReDim rob(posto).DNA(1)
  rob(posto).DNA(1).tipo = 4: rob(posto).DNA(1).value = 4
  rob(posto).DnaLen = 1
  rob(posto).Exist = False
  rob(posto).Fixed = False
  rob(posto).fname = ""
  rob(posto).genenum = 0
  rob(posto).generation = 0
  rob(posto).highlight = False
  rob(posto).Kills = 0
  rob(posto).LastMut = 0
  rob(posto).LastMutDetail = ""
  rob(posto).lastopp = 0
  rob(posto).LastOwner = ""
  rob(posto).lastviewed = 0
  rob(posto).ma = 0
  rob(posto).mass = 0
  rob(posto).maxusedvars = 0
  Erase rob(posto).mem()
  rob(posto).mt = 0
  rob(posto).Multibot = False
  Erase rob(posto).Mutables.mutarray()
  rob(posto).Mutables.Mutations = False
  rob(posto).Mutations = 0
  rob(posto).nrg = 0
  rob(posto).Numties = 0
  rob(posto).oaim = 0
  rob(posto).obody = 0
  Erase rob(posto).occurr()
  rob(posto).onrg = 0
  rob(posto).order = 0
  Erase rob(posto).OSkin()
  rob(posto).Paracount = 0
  rob(posto).Paralyzed = False
  rob(posto).Parent = 0
  rob(posto).Ploc = 0
  rob(posto).pntr = 0
  rob(posto).poison = 0
  rob(posto).Poisoncount = 0
  rob(posto).Poisoned = False
  rob(posto).Pwaste = 0
  rob(posto).radius = 0
  rob(posto).Shape = 0
  rob(posto).Shell = 0
  Erase rob(posto).Skin()
  rob(posto).Slime = 0
  rob(posto).SonNumber = 0
  Erase rob(posto).Ties()
  Erase rob(posto).usedvars()
  Erase rob(posto).vars()
  rob(posto).vbody = 0
  rob(posto).Veg = False
  rob(posto).venom = 0
  rob(posto).view = False
  rob(posto).Vloc = 0
  rob(posto).vnum = 0
  rob(posto).Vtimer = 0
  rob(posto).Vval = 0
  rob(posto).vel.x = 0
  rob(posto).vel.y = 0
  rob(posto).Wall = False
  rob(posto).Waste = 0
  rob(posto).pos.x = 0
  rob(posto).pos.y = 0
End Function

' Kill Bill
Public Sub KillRobot(n As Integer)
  If n = -1 Then n = robfocus
  
  If SimOpts.DBEnable Then
    If rob(n).Veg And SimOpts.DBExcludeVegs Then
    Else
      AddRecord n
    End If
  End If
  
  If n = MaxRobs Then
    Dim A As Integer
    Dim b As Integer
    For A = 0 To MaxRobs
      If rob(A).Exist = True Then b = A
    Next A
    MaxRobs = b 'b is now the last actual array element
  End If
  
  rob(n).Exist = False
  rob(n).Wall = False
  rob(n).Fixed = False
  rob(n).Veg = False
  rob(n).LastOwner = ""
  rob(n).SonNumber = 0
  rob(n).age = 0
  UpdateBotBucket n
  delallties n
  If Not MDIForm1.nopoff Then makepoff n
End Sub
